
SET(CMAKE_SYSTEM_NAME Generic)
SET(CMAKE_SYSTEM_VERSION 1)
SET(CAFE 1)
SET(CMAKE_HOST_SYSTEM_NAME Windows)
SET(CMAKE_HOST_SYSTEM_VERSION 1)
SET(ZLIB_FOUND 1)
SET(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)
SET(CMAKE_CROSSCOMPILING TRUE)

IF(${CMAKE_BUILD_TYPE} MATCHES "Release")
	SET(CAFE_BUILD_TYPE "NDEBUG")
ELSE()
	SET(CAFE_BUILD_TYPE "DEBUG")
ENDIF()

STRING(REPLACE \\ / MY_GHS_ROOT "$ENV{GHS_ROOT}")
STRING(REPLACE \\ / CAFE_ROOT "$ENV{CAFE_ROOT}")

SET(CMAKE_C_COMPILER "${MY_GHS_ROOT}/ccppc.exe")
set(CMAKE_C_COMPILER_ID_RUN TRUE)
set(CMAKE_C_COMPILER_ID GHS)
set(CMAKE_C_COMPILER_FORCED TRUE)
SET(CMAKE_CXX_COMPILER "${MY_GHS_ROOT}/cxppc.exe")
set(CMAKE_CXX_COMPILER_ID_RUN TRUE)
set(CMAKE_CXX_COMPILER_ID GHS)
set(CMAKE_CXX_COMPILER_FORCED TRUE)
SET(CMAKE_AR "${MY_GHS_ROOT}/ccppc.exe" CACHE FILEPATH "Archiver" FORCE)
SET(CMAKE_NM "${MY_GHS_ROOT}/gnm.exe" CACHE FILEPATH "NM" FORCE)

INCLUDE_DIRECTORIES(AFTER ${CAFE_ROOT}/system/include/)

SET(tmpflags "--no_commons -c99 -kanji=utf8 -only_explicit_reg_use --no_exceptions")
SET(tmpflags "${tmpflags} --link_once_templates -cpu=espresso -sda=none -Ogeneral -G --quit_after_warnings --Werror")
SET(tmpflags "${tmpflags} --no_implicit_include -dbg_source_root ${CAFE_ROOT}/system -MD")
SET(tmpdefs "-DNDEV=1 -DCAFE=2 -DGHS_DISABLE_NON_CRITICAL_WARNINGS -DPLATFORM=CAFE -DEPPC -DCOS_SECURITY_ENABLED=1 -DIOS_DEBUG_STARTUP_STATE=FALSE")
SET(CMAKE_C_FLAGS "${tmpflags} ${tmpdefs}" CACHE STRING "" FORCE)
SET(CMAKE_CXX_FLAGS "--g++ ${tmpflags} ${tmpdefs}" CACHE STRING "" FORCE)
SET(CMAKE_C_FLAGS_DEBUG "-O0 -g" CACHE STRING "" FORCE)
SET(CMAKE_CXX_FLAGS_DEBUG "-O0 -g" CACHE STRING "" FORCE)
SET(CMAKE_C_FLAGS_RELEASE "-O3 -DNDEBUG" CACHE STRING "" FORCE)
SET(CMAKE_CXX_FLAGS_RELEASE "-O3 -DNDEBUG" CACHE STRING "" FORCE)

SET(CMAKE_C_LINK_FLAGS "-e _start -relprog_cafe -lnk=-nosegments_always_executable -nostartfile -Mn -Mu -delete ${CAFE_ROOT}/system/include/cafe/eppc.Cafe.ld")
SET(CMAKE_CXX_LINK_FLAGS "-e _start -relprog_cafe -lnk=-nosegments_always_executable -nostartfile -Mn -Mu -delete ${CAFE_ROOT}/system/include/cafe/eppc.Cafe.ld")

SET(CMAKE_CXX_ARCHIVE_CREATE "<CMAKE_AR> -archive -o <TARGET> <LINK_FLAGS> <OBJECTS>")
SET(CMAKE_C_ARCHIVE_CREATE "<CMAKE_AR> -archive -o <TARGET> <LINK_FLAGS> <OBJECTS>")

#<CMAKE_CXX_COMPILER>  <FLAGS> <CMAKE_CXX_LINK_FLAGS> <LINK_FLAGS> <OBJECTS>  -o <TARGET> <LINK_LIBRARIES>")
#  set(CMAKE_C_LINK_EXECUTABLE
#   "<CMAKE_C_COMPILER> <FLAGS> <CMAKE_C_LINK_FLAGS> <LINK_FLAGS> <OBJECTS>  -o <TARGET> <LINK_LIBRARIES>")

SET(CMAKE_CXX_LINK_EXECUTABLE
	"echo <LINK_LIBRARIES> <OBJECTS> > <OBJECT_DIR>/lib_obj.txt"
	"echo ${CAFE_ROOT}/system/bin/tool/preprpl64 -e _start -L${CAFE_ROOT}/system/lib/ghs/cafe/${CAFE_BUILD_TYPE} -o <OBJECT_DIR>/rpl_export.o @<OBJECT_DIR>/lib_obj.txt > <OBJECT_DIR>/run_preprpl64.rsp"
	"${CMAKE_CURRENT_LIST_DIR}/rspexpand.bat <OBJECT_DIR>/run_preprpl64.rsp > <OBJECT_DIR>/run_preprpl64.bat"
	"<OBJECT_DIR>\\run_preprpl64.bat >NUL"
	"<CMAKE_CXX_COMPILER> -o <TARGET_BASE> <FLAGS> <CMAKE_CXX_LINK_FLAGS> -map=<TARGET_BASE>.map <OBJECT_DIR>/rpl_export.o -L${CAFE_ROOT}/system/lib/ghs/cafe/${CAFE_BUILD_TYPE} @<OBJECT_DIR>/lib_obj.txt"
	"${CAFE_ROOT}/system/bin/tool/makerpl64 <TARGET_BASE> -f -t BUILD_TYPE=${CAFE_BUILD_TYPE} -s -l <OBJECT_DIR>/<TARGET_BASE>.a"
	)

SET(CMAKE_C_LINK_EXECUTABLE
	"echo <LINK_LIBRARIES> <OBJECTS> > <OBJECT_DIR>/lib_obj.txt"
	"echo ${CAFE_ROOT}/system/bin/tool/preprpl64 -e _start -L${CAFE_ROOT}/system/lib/ghs/cafe/${CAFE_BUILD_TYPE} -o <OBJECT_DIR>/rpl_export.o @<OBJECT_DIR>/lib_obj.txt > <OBJECT_DIR>/run_preprpl64.rsp"
	"${CMAKE_CURRENT_LIST_DIR}/rspexpand.bat <OBJECT_DIR>/run_preprpl64.rsp > <OBJECT_DIR>/run_preprpl64.bat"
	"<OBJECT_DIR>\\run_preprpl64.bat >NUL"
	"<CMAKE_C_COMPILER> -o <TARGET_BASE> <FLAGS> <CMAKE_CXX_LINK_FLAGS> -map=<TARGET_BASE>.map <OBJECT_DIR>/rpl_export.o -L${CAFE_ROOT}/system/lib/ghs/cafe/${CAFE_BUILD_TYPE} @<OBJECT_DIR>/lib_obj.txt"
	"${CAFE_ROOT}/system/bin/tool/makerpl64 <TARGET_BASE> -f -t BUILD_TYPE=${CAFE_BUILD_TYPE} -s -l <OBJECT_DIR>/<TARGET_BASE>.a"
	)

SET(CMAKE_SIZEOF_VOID_P 4 CACHE CACHE INTERNAL "")
SET(CMAKE_EXECUTABLE_SUFFIX ".elf" CACHE INTERNAL "")

# search for programs in the build host directories
SET(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM NEVER)
# for libraries and headers in the target directories
SET(CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
SET(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)
SET(CMAKE_FIND_ROOT_PATH_MODE_PACKAGE ONLY)
