﻿
/*--------------------------------------------------------------------------------*
  Project: CrossRoad
  Copyright (C)Nintendo All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *--------------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_CONFIG_CLANG_H_
#define INCLUDE_NN_NLIB_CONFIG_CLANG_H_
#ifndef INCLUDE_NN_NLIB_CONFIG_H_
# error do not include directly
#endif

#if defined(__clang__)

#define NLIB_CXX11_SWAPHEADER

#if __cplusplus > 199711L
# define NLIB_CXX11_UNIQUEPTR
# define NLIB_CXX11_EXTERN_TEMPLATES
# define NLIB_CXX11_DEFAULT_TEMPLATE_ARGUMENT_FOR_FUNCTION_TEMPLATES
#endif

#if __has_feature(cxx_exceptions)
# define NLIB_EXCEPTION_ENABLED
#endif

#if __has_feature(cxx_lambdas)
# define NLIB_CXX11_LAMBDAS
#endif

#if __has_feature(cxx_rvalue_references)
# define NLIB_CXX11_RVALUE_REFERENCES
#endif

#if __has_feature(cxx_alias_templates)
# define NLIB_CXX11_TEMPLATE_ALIAS
#endif

#if __has_feature(cxx_deleted_functions) && __has_feature(cxx_defaulted_functions)
# define NLIB_CXX11_DEFAULTED_AND_DELETED_FUNCTIONS
#endif

#if __has_feature(cxx_explicit_conversions)
# define NLIB_CXX11_EXPLICIT_CONVERSION_OPERATORS
#endif

#if __has_feature(cxx_nullptr)
# define NLIB_CXX11_NULL_POINTER_CONSTANT
#endif

#if __has_feature(cxx_static_assert)
# define NLIB_CXX11_STATIC_ASSERTIONS
#endif

#if __has_feature(cxx_range_for)
# define NLIB_CXX11_RANGE_BASED_FOR
#endif

#if __has_feature(cxx_override_control)
# define NLIB_CXX11_EXPLICIT_VIRTUAL_OVERRIDES
#endif

#if __has_feature(cxx_constexpr)
# define NLIB_CXX11_CONSTEXPR
#endif

#if __has_feature(cxx_alignas)
# define NLIB_CXX11_ALIGNMENT_SUPPORT
#endif

#if __has_feature(cxx_variadic_templates)
# define NLIB_CXX11_VARIADIC_TEMPLATES
#endif

#if __has_feature(cxx_delegating_constructors)
# define NLIB_CXX11_DELEGATING_CONSTRUCTORS
#endif

#if __has_include(<chrono>)
# define NLIB_CXX11_STDLIB_CHRONO
#endif

#if __has_include(<atomic>)
# define NLIB_CXX11_STDLIB_ATOMIC
#endif

#if __has_include(<random>)
# define NLIB_CXX11_STDLIB_RANDOM
#endif

#if __has_include(<array>)
# define NLIB_CXX11_STDLIB_ARRAY
#endif

#if __has_include(<unordered_set>) && __has_include(<unordered_map>)
# define NLIB_CXX11_STDLIB_UNORDERED
#endif

#if __has_include(<tuple>)
# define NLIB_CXX11_STDLIB_TUPLE
#endif

#include <cassert> // NOLINT
#ifndef NLIB_ASSERT
#define NLIB_ASSERT assert
#endif

#define NLIB_ALIGNAS(x) __attribute__((aligned(x)))
#define NLIB_ALIGNOF(tp) __alignof__(tp)

#define NLIB_HAS_NATIVE_TYPETRAITS

// libstdc++ workaround, See https://svn.boost.org/trac/boost/ticket/7473
#if !__has_include(<ext/cmath>) && !__has_include(<ext/__hash>)
# ifdef NLIB_CXX11_STDLIB_ATOMIC
#  undef NLIB_CXX11_STDLIB_ATOMIC
# endif
# ifdef NLIB_HAS_NATIVE_TYPETRAITS
#  undef NLIB_HAS_NATIVE_TYPETRAITS
# endif
# ifdef NLIB_CXX11_STDLIB_RANDOM
#  undef NLIB_CXX11_STDLIB_RANDOM
# endif
#endif

// libstdc++ workaround, See https://svn.boost.org/trac/boost/ticket/7473
#if !__has_include(<future>)
# ifdef NLIB_CXX11_UNIQUEPTR
#  undef NLIB_CXX11_UNIQUEPTR
# endif
# ifdef NLIB_CXX11_STDLIB_UNORDERED
#  undef NLIB_CXX11_STDLIB_UNORDERED
# endif
# ifdef NLIB_CXX11_STDLIB_TUPLE
#  undef NLIB_CXX11_STDLIB_TUPLE
# endif
#endif

#endif
#endif  // INCLUDE_NN_NLIB_CONFIG_CLANG_H_
