﻿
/*--------------------------------------------------------------------------------*
  Project: CrossRoad
  Copyright (C)Nintendo All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *--------------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_WCHARINPUTSTREAM_H_
#define INCLUDE_NN_NLIB_WCHARINPUTSTREAM_H_

#include "nn/nlib/InputConverterStream.h"

NLIB_NAMESPACE_BEGIN
class NLIB_VIS_PUBLIC Utf16InputStream : public InputConverterStream {
 public:
    Utf16InputStream() NLIB_NOEXCEPT : prv_(NULL) {}
    errno_t Init() NLIB_NOEXCEPT;
    virtual ~Utf16InputStream() NLIB_NOEXCEPT;

 private:
    struct Utf16InputStreamPrivate;
    Utf16InputStreamPrivate* prv_;
};

class NLIB_VIS_PUBLIC Utf32InputStream : public InputConverterStream {
 public:
    Utf32InputStream() NLIB_NOEXCEPT : prv_(NULL) {}
    errno_t Init() NLIB_NOEXCEPT;
    virtual ~Utf32InputStream() NLIB_NOEXCEPT;

 private:
    struct Utf32InputStreamPrivate;
    Utf32InputStreamPrivate* prv_;
};

#ifndef NLIB_DOXYGEN
#if NLIB_WCHAR_SIZE == 4
typedef Utf32InputStream WcharInputStream;
#else
typedef Utf16InputStream WcharInputStream;
#endif
#else
#if NLIB_WCHAR_SIZE == 4
class WcharInputStream NLIB_FINAL : public Utf32InputStream {
 public:
};
#else
class WcharInputStream NLIB_FINAL : public Utf16InputStream {
 public:
};
#endif
#endif
NLIB_NAMESPACE_END

#endif  // INCLUDE_NN_NLIB_WCHARINPUTSTREAM_H_
