Param([string]$CMake = "cmake.exe")

Push-Location .
$scriptDir = Split-Path -Parent $MyInvocation.MyCommand.Path
Set-Location $scriptDir

Set-Item Env:Path ((($Env:Path -split ';') -match '^(?!.*cygwin)') -join ';')

Push-Location .
try {
    New-Item ctr\Release -ItemType Directory
    Set-Location ctr\Release
    & $CMake -G Ninja -D CMAKE_TOOLCHAIN_FILE=..\..\..\cmake\toolchain-ctr-ninja.cmake -D CMAKE_BUILD_TYPE=Release ..\..\
    if ($LastExitCode -ne 0) { throw }
} catch {
    Set-Location ..\..\
    Remove-Item ctr\Release -Recurse -Force
    throw
} finally {
    Pop-Location
}

Push-Location .
try {
    New-Item ctr\Debug -ItemType Directory
    Set-Location ctr\Debug
    & $CMake -G Ninja -D CMAKE_TOOLCHAIN_FILE=..\..\..\cmake\toolchain-ctr-ninja.cmake -D CMAKE_BUILD_TYPE=Debug ..\..\
    if ($LastExitCode -ne 0) { throw }
} catch {
    Set-Location ..\..\
    Remove-Item ctr\Debug -Recurse -Force
    throw
} finally {
    Pop-Location
}

Push-Location .
try {
    New-Item ctr\RelWithDebInfo -ItemType Directory
    Set-Location ctr\RelWithDebInfo
    & $CMake -G Ninja -D CMAKE_TOOLCHAIN_FILE=..\..\..\cmake\toolchain-ctr-ninja.cmake -D CMAKE_BUILD_TYPE=RelWithDebInfo ..\..\
    if ($LastExitCode -ne 0) { throw }
} catch {
    Set-Location ..\..\
    Remove-Item ctr\RelWithDebInfo -Recurse -Force
    throw
} finally {
    Pop-Location
}

Pop-Location
