add_sample(succinct bitvector nx_succinct)
add_sample(succinct detection nx_succinct)
add_sample(succinct ngc nx_succinct)
add_sample(succinct simple nx_succinct)

IF(CAFE)
	IF($ENV{CAFE_SAVE_DIR})
		nlib_cygwin_getcygpath($ENV{CAFE_SAVE_DIR}/nlibsample MY_DIR)
	ELSE()
		nlib_cygwin_getcygpath($ENV{CAFE_ROOT}/data/save/nlibsample MY_DIR)
	ENDIF()
	GET_FILENAME_COMPONENT(MY_DIR ${MY_DIR} ABSOLUTE)
ELSEIF(CTR)
	nlib_cygwin_getcygpath(${CMAKE_BINARY_DIR}/resource MY_DIR)
	SET_PROPERTY(TARGET succinct_detection APPEND PROPERTY
		COMPILE_DEFINITIONS "NLIB_CTR_SAMPLE_USEFILE")
	nlib_cygwin_getwinpath(${MY_DIR} respath)
	FILE(WRITE ${CMAKE_BINARY_DIR}/CMakeFiles/succinct_detection.dir/detection.rsf
		"BasicInfo:\n"
		"  BackupMemoryType: None\n"
		"  Title: detection\n"
		"Rom:\n"
		"  HostRoot: ${respath}\n"
		"CardInfo:\n"
		"  CardDevice: None\n"
		"TitleInfo:\n"
		"  UniqueId: 0xff3f\n"
		"AccessControlInfo:\n"
		"  FileSystemAccess:\n"
		"    - Debug\n"
		"    - DirectSdmc\n"
	)
	SET_PROPERTY(TARGET succinct_detection PROPERTY
		CTR_SPEC_RSF "${CMAKE_BINARY_DIR}/CMakeFiles/succinct_detection.dir/detection.rsf")
	generate_ctr_makeromopt(succinct_detection)
ELSE()
	UNSET(MY_DIR)
ENDIF()

IF(MY_DIR)
	SET(myprefix "${MY_DIR}/")
ELSE()
	SET(myprefix "")
ENDIF()

MACRO(cp_txt file)
	IF(BASH_UBUNTU_WINDOWS)
		# 'cmake -E copy_if_different' is sometimes unstable
		ADD_CUSTOM_COMMAND(
			OUTPUT ${file}
			COMMAND cp
			ARGS -u ${NLIB_PKGROOT_DIR}/samples/sources/succinct/resource/${file} ${file}
			DEPENDS ${NLIB_PKGROOT_DIR}/samples/sources/succinct/resource/${file}
			BYPRODUCTS
		)
	ELSEIF(WIN32)
		# 'cmake -E copy_if_different' is sometimes unstable
		STRING(REPLACE "/" "\\" tmp "${NLIB_PKGROOT_DIR}")
		ADD_CUSTOM_COMMAND(
			OUTPUT ${file}
			COMMAND copy
			ARGS /B /Y "${tmp}\\samples\\sources\\succinct\\resource\\${file}" ${file}
			DEPENDS ${NLIB_PKGROOT_DIR}/samples/sources/succinct/resource/${file}
			BYPRODUCTS
		)
	ELSE()
		ADD_CUSTOM_COMMAND(
			OUTPUT ${file}
			COMMAND cmake
			ARGS -E copy_if_different ${NLIB_PKGROOT_DIR}/samples/sources/succinct/resource/${file} ${file}
			DEPENDS ${NLIB_PKGROOT_DIR}/samples/sources/succinct/resource/${file}
			BYPRODUCTS
		)
		IF(MY_DIR)
			ADD_CUSTOM_COMMAND(
				OUTPUT ${myprefix}${file}
				COMMAND cmake
				ARGS -E copy_if_different ${file} ${myprefix}${file}
				DEPENDS ${file}
				BYPRODUCTS
			)
		ENDIF()
	ENDIF()
ENDMACRO()

MACRO(cp_txt2 file)
	FILE(LOCK ${NLIB_PKGROOT_DIR}/samples/sources/succinct/resource DIRECTORY)
	FILE(COPY ${NLIB_PKGROOT_DIR}/samples/sources/succinct/resource/${file} DESTINATION .)
	FILE(LOCK ${NLIB_PKGROOT_DIR}/samples/sources/succinct/resource DIRECTORY RELEASE)
	IF(MY_DIR)
		FILE(COPY ${NLIB_PKGROOT_DIR}/samples/sources/succinct/resource/${file} DESTINATION ${MY_DIR})
	ENDIF()
ENDMACRO()

IF(NOT TARGET ac)
#	SET(AC ${NLIB_TOOL_DIR}/ac)
	ADD_EXECUTABLE(ac IMPORTED)
	SET_PROPERTY(TARGET ac PROPERTY IMPORTED_LOCATION "${NLIB_TOOL_DIR}/ac")
ELSE()
#	SET(AC ac)
ENDIF()

# IF(UNIX AND NOT CYGWIN)
# 	SET(LD_LIBPATH "LD_LIBRARY_PATH=${NLIB_DIR}")
# ELSE()
# 	UNSET(LD_LIBPATH)
# ENDIF()

MACRO(make_acfile name)
	ADD_CUSTOM_COMMAND(
		OUTPUT ${name}.ac
		COMMAND ac
		ARGS --output_file=${name}.ac --input_file=${name}.txt
		DEPENDS ${CMAKE_BINARY_DIR}/${name}.txt
		BYPRODUCTS
	)
	IF(MY_DIR)
		ADD_CUSTOM_COMMAND(
			OUTPUT ${myprefix}${name}.ac
			COMMAND cmake
			ARGS -E copy_if_different ${name}.ac ${myprefix}${name}.ac
			DEPENDS ${CMAKE_BINARY_DIR}/${name}.ac
			BYPRODUCTS
		)
	ENDIF()
ENDMACRO()

cp_txt2(adjv.txt)
cp_txt2(kokoro.txt)
cp_txt2(shayo.txt)

make_acfile(adjv)

# release build only(heavy)
IF(NOT CTR AND ${CMAKE_BUILD_TYPE} MATCHES "Release")
	add_sample(succinct kwlink nx_succinct)
	cp_txt2(wikipedia.txt)
	make_acfile(wikipedia)

	#ADD_CUSTOM_TARGET(txtfiles ALL DEPENDS ${myprefix}wikipedia.txt ${myprefix}adjv.txt ${myprefix}kokoro.txt ${myprefix}shayo.txt)
	ADD_CUSTOM_TARGET(acfiles ALL DEPENDS ${myprefix}wikipedia.ac ${myprefix}adjv.ac)
ELSE()
	#ADD_CUSTOM_TARGET(txtfiles ALL DEPENDS ${myprefix}adjv.txt ${myprefix}kokoro.txt ${myprefix}shayo.txt)
	ADD_CUSTOM_TARGET(acfiles ALL DEPENDS ${myprefix}adjv.ac)
ENDIF()

