#!/bin/sh

if ! [ -d /mnt/c ]; then
  echo Please call this script from bash on ubuntu on Windows.
  exit 1
fi

if ! [ "$(uname)" = "Linux" ]; then
  echo Please call this script from bash on ubuntu on Windows.
  exit 1
fi

cd $(dirname $0)

sudo -E apt-get install make gcc g++ clang
sudo -E apt-get install git gcovr tar gzip
sudo -E apt-get install zlib1g-dev libxml2 libcurl4-openssl-dev
sudo -E apt-get install libboost-system-dev libboost-thread-dev libboost-date-time-dev libboost-regex-dev

if [ ! -e /usr/local/bin/cmake ]; then
 cd
 # needs 'https_proxy=http://${xxx.xxx.xxx.xxx}:${ss}/' in ~/.wgetrc if proxy needed
 wget -nc -O - https://cmake.org/files/v3.7/cmake-3.7.1-Linux-x86_64.tar.gz | tar zxvf -
 sudo -E ln -s $HOME/cmake-3.7.1-Linux-x86_64/bin/cmake /usr/local/bin/cmake
 sudo -E ln -s $HOME/cmake-3.7.1-Linux-x86_64/bin/ccmake /usr/local/bin/ccmake
 sudo -E ln -s $HOME/cmake-3.7.1-Linux-x86_64/bin/ctest /usr/local/bin/ctest
 sudo -E ln -s $HOME/cmake-3.7.1-Linux-x86_64/bin/cmake-gui /usr/local/bin/cmake-gui
 sudo -E ln -s $HOME/cmake-3.7.1-Linux-x86_64/bin/cpack /usr/local/bin/cpack
 cd $(dirname $0)
fi
